package com.uc.base.net;

import android.os.Looper;

import com.uc.base.net.metrics.IHttpConnectionMetrics;

public class HttpClientAsync implements IHttpClientAsync {

    private IHttpClientAsync mImpl;

    public HttpClientAsync(IHttpEventListener listener, Looper looper) {
        mImpl = NetworkManager.getInstance().getNetClientDelegate().createAsyncClient(listener, looper);
    }

    /**
     * construct a asynchronous http request width default loopger(main looper), and the callback will run on main
     * thread(UI thread)
     */
    public HttpClientAsync(IHttpEventListener listener) {
        mImpl = NetworkManager.getInstance().getNetClientDelegate().createAsyncClient(listener);
    }


    @Override
    public void sendRequest(final IRequest request) {
        mImpl.sendRequest(request);
    }

    @Override
    public void setProxy(final String url, final int port) {
        mImpl.setProxy(url, port);
    }

    @Override
    public void sendRequest(final IRequest request, final boolean highPriority) {
        mImpl.sendRequest(request, highPriority);
    }

    @Override
    public void cancel(final IRequest request) {
        mImpl.cancel(request);
    }

    @Override
    public IHttpConnectionMetrics getHttpConnectionMetrics() {
        return mImpl.getHttpConnectionMetrics();
    }

    @Override
    public void setDataDecompressEventListener(final IDataDecompressEventListener listener) {
        mImpl.setDataDecompressEventListener(listener);
    }

    @Override
    public IDataDecompressEventListener getDataDecompressEventListener() {
        return mImpl.getDataDecompressEventListener();
    }

    @Override
    public void setConnectionTimeout(final int timeout) {
        mImpl.setConnectionTimeout(timeout);
    }

    @Override
    public void setRequestTimeout(int timeout) {
        mImpl.setRequestTimeout(timeout);
    }

    @Override
    public void setSocketTimeout(final int timeout) {
        mImpl.setSocketTimeout(timeout);
    }

    @Override
    public void setAuth(final String username, final String password) {
        mImpl.setAuth(username, password);
    }

    @Override
    public IRequest getRequest(final String url) throws IllegalArgumentException {
        return mImpl.getRequest(url);
    }

    @Override
    public void setMetricsTAG(final String tag) {
        mImpl.setMetricsTAG(tag);
    }
}
