package com.uc.base.net;

import com.uc.base.net.metrics.IHttpConnectionMetrics;

public class HttpClientSync implements IHttpClientSync {

    private IHttpClientSync mImpl;

    public HttpClientSync() {
        mImpl = NetworkManager.getInstance().getNetClientDelegate().createSyncClient();
    }

    @Override
    public IResponse sendRequest(final IRequest request) {
        return mImpl.sendRequest(request);
    }

    @Override
    public void close() {
        mImpl.close();
    }

    @Override
    public int errorCode() {
        return mImpl.errorCode();
    }

    @Override
    public void followRedirects(final boolean follow) {
        mImpl.followRedirects(follow);
    }

    @Override
    public IHttpConnectionMetrics getHttpConnectionMetrics() {
        return mImpl.getHttpConnectionMetrics();
    }

    @Override
    public void recycle(final int keepTime) {
        mImpl.recycle(keepTime);
    }

    @Override
    public void setConnectionTimeout(final int timeout) {
        mImpl.setConnectionTimeout(timeout);
    }

    @Override
    public void setRequestTimeout(int timeout) {
        mImpl.setRequestTimeout(timeout);
    }

    @Override
    public void setSocketTimeout(final int timeout) {
        mImpl.setSocketTimeout(timeout);
    }

    @Override
    public void setAuth(final String username, final String password) {
        mImpl.setAuth(username, password);
    }

    @Override
    public void setProxy(final String url, final int port) {
        mImpl.setProxy(url, port);
    }

    @Override
    public IRequest getRequest(final String url) throws IllegalArgumentException {
        return mImpl.getRequest(url);
    }

    @Override
    public void setMetricsTAG(final String tag) {
        mImpl.setMetricsTAG(tag);
    }

    @Override
    public void setFollowProxy(boolean followProxy) {
        mImpl.setFollowProxy(followProxy);
    }
}
