/**  
 *****************************************************************************
 * Copyright (C) 2005-2014 UCWEB Corporation. All rights reserved
 * File        : 2014-3-4
 *
 * Description : 
 *
 * Creation    : 2014-3-4
 * Author      : linhz@ucweb.com
 * History     : Creation, 2014-3-4, linhz, Create the file
 *****************************************************************************
 */
package com.uc.base.net;


import com.uc.base.net.adaptor.Headers;
import com.uc.base.net.metrics.IHttpConnectionMetrics;

/**
 * User Interface for monitor events.
 */
public interface IHttpEventListener {
    
    public void onStatusMessage(String protocol, int statusCode, String statusMessage);

    public void onError(int errorId, String errorMsg);

    public void onHeaderReceived(Headers headers);

    public void onBodyReceived(byte[] data, int length);

    public void onRequestCancel();

    // return true means redirect URL has handled by EventListener,so network will NOT follow redirect automatically.
    // return false means EventListener do nothing for this and make network follow redirect automatically.
    public boolean onRedirect(String redirectTo);

    public void onMetrics(IHttpConnectionMetrics metrics);
}
