package com.uc.base.net;

/**
 * 网络库静态功能代理
 */
public interface INetFuncDelegate {

    /**
     * 预连接
     * @param url
     * @param isSync
     * @param keepTime
     * @return
     */
    boolean preConnect(String url, boolean isSync, int keepTime);

    /**
     * 设置系统代理
     * @param host
     * @param port
     */
    void setSystemProxy(String host, int port);

    /**
     * 返回设置的系统代理以":"分隔host port
     * @return
     */
    String getSystemProxy();

    /**
     * 添加DNS解析结果到DNS缓存, 仅uNet实现
     * @param host
     * @param ipsStr
     * @param ttlSec
     */
    void addPreResolveDns(String host, String ipsStr, int ttlSec);

    /**
     * 删除DnsCache
     */
    void clearDnsCache();

    void clearDnsCache(String host);

    /**
     * 设置参数， 仅uNet实现
     * @param key
     * @param value
     */
    void setArgs(String key, String value);

    /**
     * 设置参数，仅uNet实现
     * @param key
     * @param value
     */
    void setArgs(String key, int value);

    /**
     * 返回网络库实现类型
     * 默认支持{@link NetworkManager#NET_LIB_IMPL_TYPE_LEGACY }
     * 或者 {@link NetworkManager#NET_LIB_IMPL_TYPE_UNET}
     * @return
     */
    String getNetImplLibType();

    /**
     * 是否启用了uPaaS功能
     * @return
     */
    boolean isUPaaSEnable();
}
