package com.uc.base.net.metrics;

public class HttpConnectionMetrics implements IHttpConnectionMetrics {
    /* package */ HttpConnectionMetricsConnection mConnectionMetrics = null;
    /* package */ static HttpConnectionMetricsBase mMetricsGlobal = new HttpConnectionMetricsGlobal();
    /* package */ static HttpConnectionMetricsBase mMetricsBusiness = new HttpConnectionMetricsBusiness();

    public HttpConnectionMetrics(HttpConnectionMetricsConnection metrics) {
        mConnectionMetrics = metrics;
    }

    @Override
    public String getMetrics(int metricsLevel, String tag, HttpConnectionMetricsType metricsType) {
        if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_GLOBAL) {
            return mMetricsGlobal.getMetrics(null, metricsType);

        } else if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_BUSINESS) {
            return mMetricsBusiness.getMetrics(tag, metricsType);

        } else if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_CONNECTION) {
            return mConnectionMetrics.getMetrics(metricsType);
        }

        return null;
    }

    @Override
    public void resetMetrics(int metricsLevel, String tag) {
        if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_GLOBAL) {
            mMetricsGlobal.resetMetrics(tag);

        } else if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_BUSINESS) {
            mMetricsBusiness.resetMetrics(tag);

        } else if (metricsLevel == HttpConnectionMetricsLevel.METRICS_LEVEL_CONNECTION) {
            mConnectionMetrics.resetMetrics(tag);
        }
    }

    @Override
    public IHttpConnectionMetrics clone() {
        HttpConnectionMetricsConnection conn = mConnectionMetrics.clone();
        HttpConnectionMetrics metrics = new HttpConnectionMetrics(conn);
        return metrics;
    }
}
