package com.uc.base.net.metrics;

/* package */ abstract class HttpConnectionMetricsBase implements HttpConnectionMetricsListener {

    /**
     * get special metrics
     * @param tag user defined
     * @param metricsType HttpConnectionMetricsType
     * @return metrics params
     */
    public abstract String getMetrics(String tag, HttpConnectionMetricsType metricsType);

    /**
     * metrics for sent bytes
     * @param tag user defined
     * @return sent bytes
     */
    public abstract long getSentBytesCount(String tag);

    /**
     * metrics for sent bytes
     * @param tag user defined
     * @return sent bytes
     */
    public abstract long getReceivedBytesCount(String tag);

    /**
     * metrics for request.
     * @return times for request.
     */
    public abstract long getRequestCount(String tag);

    /**
     * metrics for receive response.
     * @return times for receive response
     */
    public abstract long getResponseCount(String tag);

    /**
     * same as resetMetrics
     * @param tag user defined
     */
    public abstract void resetMetrics(String tag);
}
