package com.uc.base.net.metrics;

public enum HttpConnectionMetricsType {
    /**
     * sent bytes
     */
    METRICS_TYPE_SENT_BYTES_COUNT,
    /**
     * receive bytes
     */
    METRICS_TYPE_RECEIVED_BYTES_COUNT,
    /**
     * times for request
     */
    METRICS_TYPE_REQUEST_COUNT,
    /**
     * times for received response
     */
    METRICS_TYPE_RESPONSE_COUNT,
    /**
     * remote address.
     */
    METRICS_TYPE_REMOTE_ADDRESS,
    /**
     * remote port.
     */
    METRICS_TYPE_REMOTE_PORT,
    /**
     * time for dns parsing
     */
    METRICS_TYPE_DNS_PARSE_TIME,
    /**
     * time for socket connection.
     */
    METRICS_TYPE_CONNECTION_TIME,
    /**
     * time for RTT(request and received response)
     */
    METRICS_TYPE_RTT_TIME,
    /**
     * time for start record RTT.
     */
    METRICS_TYPE_RTT_START_TIME,

    METRICS_TYPE_ZSTD_DICT_ID,

    METRICS_TYPE_AFTER_DECOMPRESS_BYTES,

    METRICS_TYPE_DECOMPRESS_ALG,

    /**
     * 连接次数
     */
    METRICS_TYPE_CONNECT_COUNT,

    /**
     * 连接成功时的DNS来源 DNS 来源
     */
    METRICS_TYPE_CONNECTED_DNS_SOURCE,

    /**
     * uServer状态，0 未准备好 1， 使用uServer 2，uServer失败降级
     */
    METRICS_TYPE_USERVER_STATUS,

    /**
     * uServer连接失败时的错误码
     */
    METRICS_TYPE_USERVER_ERRORCODE,

    METRICS_TYPE_USERVER_MASTER_URL,

    METRICS_TYPE_LINKUP_URL;
    /**
     * convert Integer to enum
     * @param value value of HttpConnectionMetricsType
     * @return HttpConnectionMetricsType in enum form
     */
    public static HttpConnectionMetricsType fromInteger(int value) {
        if (value >= 0 && value < HttpConnectionMetricsType.values().length) {
            return HttpConnectionMetricsType.values()[value];
        }
        return null;
    }
}
