/**  
 *****************************************************************************
 * Copyright (C) 2005-2014 UCWEB Corporation. All rights reserved
 * File        : 2014-3-24
 *
 * Description : 
 *
 * Creation    : 2014-3-24
 * Author      : linhz@ucweb.com
 * History     : Creation, 2014-3-24, linhz, Create the file
 *****************************************************************************
 */
package com.uc.base.net.natives;


import com.uc.annotation.InvokeType;
import com.uc.annotation.Invoker;
import com.uc.base.net.HttpClientSync;
import com.uc.base.net.IRequest;
import com.uc.base.net.IResponse;

/* package */class NativeHttpClientSync {

    private HttpClientSync mImpl;
    
    @Invoker(type = InvokeType.Native)
    public NativeHttpClientSync() {
        mImpl = new HttpClientSync();
    }
    
    @Invoker(type = InvokeType.Native)
    public NativeRequest getNativeRequest(String url) {
        return (new NativeRequest(mImpl.getRequest(url)));
    }
    
    @Invoker(type = InvokeType.Native)
    public void close() {
        mImpl.close();
    }
    
    @Invoker(type = InvokeType.Native)
    public int errorCode() {
        return mImpl.errorCode();
    }
    
    @Invoker(type = InvokeType.Native)
    public void setConnectionTimeout(int timeout) {
        mImpl.setConnectionTimeout(timeout);
    }
    
    @Invoker(type = InvokeType.Native)
    public void setSocketTimeout(int timeout) {
        mImpl.setSocketTimeout(timeout);
    }
    
    @Invoker(type = InvokeType.Native)
    public void setAuth(String username, String password) {
        mImpl.setAuth(username, password);
    }
    
    @Invoker(type = InvokeType.Native)
    public NativeResponse sendRequest(NativeRequest nativeRequest) {
        IRequest request = nativeRequest.getRequest();
        if (request != null) {
            IResponse response = mImpl.sendRequest(request);
            return new NativeResponse(response);
        }
        return null;
    }
    
    @Invoker(type = InvokeType.Native)
    public void followRedirects(boolean auto) {
        mImpl.followRedirects(auto);
    }

    @Invoker(type = InvokeType.Native)
    public NativeHttpConnectionMetrics getMetrics() {
        return  (new NativeHttpConnectionMetrics(mImpl.getHttpConnectionMetrics()));
    }
}
