package com.uc.base.net.natives;

import com.uc.base.net.metrics.HttpConnectionMetricsType;
import com.uc.base.net.metrics.IHttpConnectionMetrics;
import com.uc.annotation.InvokeType;
import com.uc.annotation.Invoker;

/* package */ class NativeHttpConnectionMetrics {
    private IHttpConnectionMetrics mMetrics;

    public NativeHttpConnectionMetrics(IHttpConnectionMetrics metrics) {
        mMetrics = metrics;
    }

    @Invoker(type = InvokeType.Native)
    public String getMetrics(int metricsLevel, String tag, int  metricsType) {
        if (mMetrics != null) {
            return mMetrics.getMetrics(metricsLevel, tag, HttpConnectionMetricsType.fromInteger(metricsType));
        }
        return null;
    }

    @Invoker(type = InvokeType.Native)
    public void resetMetrics(int metricsLevel, String tag) {
        if (mMetrics != null) {
            mMetrics.resetMetrics(metricsLevel, tag);
        }
    }
}
