package com.uc.base.net.unet.util;

import android.text.TextUtils;

import com.alibaba.mbg.unet.Response;
import com.uc.base.net.IResponse;


import java.util.List;
import java.util.Map;

public class HttpUtil {

    public static String getProtocolVersion(Response response) {

        String negotiatedProtocol = response.getNegotiatedProtocol();

        // 优先获取negotatedProtocol 字段
        if ("h2".equalsIgnoreCase(negotiatedProtocol)
                || "http2".equalsIgnoreCase(negotiatedProtocol)
                || "http2.0".equalsIgnoreCase(negotiatedProtocol)) {
            return IResponse.PROTOCOL_HTTP2;
        }

        return IResponse.PROTOCOL_HTTP1;
    }

    public static String getHeaderFromResponse(Response response, String key) {
        if (response == null || TextUtils.isEmpty(key)) {
            return "";
        }
        Map<String, List<String>> headers = response.getAllHeaders();
        if (headers == null) {
            return "";
        }
        // Response 返回的额HeaderMap为TreeMap<>(String.CASE_INSENSITIVE_ORDER)，
        // 获取值时key可忽略大小写
        List<String> values = headers.get(key);
        if (values == null || values.size() <= 0) {
            return "";
        }
        return values.get(0);
    }
}
