package com.uc.base.net.util;

import java.util.Collection;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;

public class DoubleKeyMap<Key1, Key2, Value> {
    Map<Key1, Map<Key2, Value>> data = new LinkedHashMap<Key1, Map<Key2, Value>>();

    public Value put(Key1 k1, Key2 k2, Value v) {
        Map<Key2, Value> data2 = data.get(k1);
        Value prev = null;
        if ( data2 == null ) {
            data2 = new LinkedHashMap<Key2, Value>();
            data.put(k1, data2);
        }
        else {
            prev = data2.get(k2);
        }
        data2.put(k2, v);
        return prev;
    }

    public Value get(Key1 k1, Key2 k2) {
        Map<Key2, Value> data2 = data.get(k1);
        if ( data2==null ) return null;
        return data2.get(k2);
    }

    public Map<Key2, Value> get(Key1 k1) { return data.get(k1); }

    /** Get all values associated with primary key */
    public Collection<Value> values(Key1 k1) {
        Map<Key2, Value> data2 = data.get(k1);
        if ( data2==null ) return null;
        return data2.values();
    }

    /** get all primary keys */
    public Set<Key1> keySet() {
        return data.keySet();
    }

    /** get all secondary keys associated with a primary key */
    public Set<Key2> keySet(Key1 k1) {
        Map<Key2, Value> data2 = data.get(k1);
        if ( data2==null ) return null;
        return data2.keySet();
    }

    public void clear() {
        data.clear();
    }

    public void clear(Key1 k1) {
        Map<Key2, Value> data2 = get(k1);
        if (data2 != null) {
            data2.clear();
        }
    }
}

