/*
 * Copyright (C) 2004 - 2015 UCWeb Inc. All Rights Reserved.
 * Description : This is my code. Do not even change a single 
 * line, otherwise ... ^_*
 *
 * Creation    :  2016/10/14
 * Author      : zhibin.rzb@alibaba-inc.com
 */
package com.uc.base.net.util.dns;
import java.util.concurrent.ConcurrentHashMap;

import android.text.TextUtils;

public class BackupIpProvider {
    private static ConcurrentHashMap<String, String[]> sBackupIpMap = new ConcurrentHashMap<String, String[]>();

    public static void put(String host, String ip) {
        if (TextUtils.isEmpty(host) || TextUtils.isEmpty(ip)) {
            return;
        }
        sBackupIpMap.put(host, new String[]{ip});
    }

    public static void put(String host, String[] ip) {
        if (TextUtils.isEmpty(host) || ip == null) {
            return;
        }
        sBackupIpMap.put(host, ip);
    }


    public static String[] getAddresses(String host) {
        return sBackupIpMap.get(host);
    }

    public static void clear() {
        sBackupIpMap.clear();
    }
}
