/*
 * Copyright (C) 2004 - 2015 UCWeb Inc. All Rights Reserved.
 * Description : This is my code. Do not even change a single 
 * line, otherwise ... ^_*
 *
 * Creation    :  2016/12/15
 * Author      : zhibin.rzb@alibaba-inc.com
 */

package com.uc.base.net.util.dns;

public class PreResolveIpProviderProxy implements IPreResolveIpProvider {
    private IPreResolveIpProvider mPreResolveIpProvider;

    private static class Holder {
        private final static PreResolveIpProviderProxy INSTANCE = new PreResolveIpProviderProxy();
    }

    public static PreResolveIpProviderProxy getInstance() {
        return Holder.INSTANCE;
    }

    private PreResolveIpProviderProxy() {
    }

    public void setPreResolveIpProvider(IPreResolveIpProvider preResolveIpProvider) {
        mPreResolveIpProvider = preResolveIpProvider;
    }

    @Override
    public String[] get(String host) {
        if (mPreResolveIpProvider != null) {
            return mPreResolveIpProvider.get(host);
        }
        return null;
    }

   @Override
    public void notifyConnectResult(String host,boolean isSucceed) {
        if (mPreResolveIpProvider != null) {
            mPreResolveIpProvider.notifyConnectResult(host,isSucceed);
        }
    }


}
